﻿© Fluke. All Rights Reserved.                               MET/CAL Procedure
=============================================================================
INSTRUMENT:            Sub Select Guardbanding Method
INSTRUMENT:            Sub Select Guardbanding & Ver Method
INSTRUMENT:            Sub Select Guardbanding & Ver Method (No NTHROW)
DATE:                  2011-06-24 10:56:06
AUTHOR:                Fluke
REVISION:              $Revision: 1.5 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       1
NUMBER OF LINES:       108
=============================================================================
#
#  Text Source:
#    $RCSfile: sub_select_gb_method.txt,v $
#    $Date: 2010/10/28 18:29:35 $
#
#  Procedure Author:
#    DAC, DFM
#
#  Compatibility:
#    5500/CAL or MET/CAL 7.20 or later
#
#  Subprocedures:
#    None
#
#  Required Files:
#    None
#
#  Example Usage:
#
#    Manual Meter Procedure
#
#      1.001  CALL         Sub Select Guardbanding Method
#      1.005  VSET         NTHROW = 0; NMEAS = 1
#
#      or
#
#      1.001  CALL         Sub Select Guardbanding & Ver Method (No NTHROW)
#
#    Closed-loop Meter Procedure
#
#      1.001  CALL         Sub Select Guardbanding Method
#      1.005  VSET         NTHROW = 1; NMEAS = 5
#
#      or
#
#      1.001  CALL         Sub Select Guardbanding & Ver Method
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

  1.001  DO
  1.002  MEMI         Because some or all of the tests performed in this
  1.002  MEMI         verification have low TUR/TAR, a guardbanding strategy
  1.002  MEMI         is used to ensure the integrity of the measurements is
  1.002  MEMI         not compromised.
  1.002  MEMI
  1.002  MEMI         Please select the desired guardbanding method.
  1.002  MEMI
  1.002  MEMI         1. Measurement Uncertainty
  1.002  MEMI         2. Root Difference Square
  1.002  MEMI

  1.003  IF           MEM == 1
  1.004  MEM2         =MU
  1.005  ELSEIF       MEM == 2
  1.006  MEM2         =RDS
  1.007  ELSE
  1.008  DISP         You must enter 1 or 2.
  1.009  ENDIF

  1.010  UNTIL        (MEM == 1) || (MEM == 2)

  1.011  IF           ZCMPI(MEM2, "MU")
  1.012  RSLT         =
  1.013  RSLT         =Measurement Uncertainty guardbanding method used
  1.014  ELSE
  1.015  RSLT         =
  1.016  RSLT         =Root Difference Square guardbanding method used
  1.017  ENDIF

# Enable selected method.
  1.018  VSET         GB = [MEM2]
  1.019  MATH         @Guardbanding = MEM2

  1.020  IF           PSUBI("Ver Method")

  1.021  IF           ZCMP(@Guardbanding, "MU")
  1.022  MATH         @MeasMode = "MU"; @NMeas = 5
  1.023  VSET         NMEAS = 5
  1.024  ELSE
  1.025  MATH         @MeasMode = "TAR"; @NMeas = 1
  1.026  VSET         NMEAS = 1
  1.027  ENDIF

  1.028  IF           PSUBI("No NTHROW")
  1.029  MATH         @NThrow = 0
  1.030  VSET         NTHROW = 0
  1.031  ELSE
  1.032  MATH         @NThrow = 1
  1.033  VSET         NTHROW = 1
  1.034  ENDIF

  1.035  MATH         @MeasOnly = "Yes"; @NSD = 3
  1.036  VSET         MEASURE_ONLY = Yes; NSD = 3
  1.037  ENDIF

  1.038  END
