﻿© Fluke. All Rights Reserved.                               MET/CAL Procedure
=============================================================================
INSTRUMENT:            Sub Tek TX1/TX3 Query Identification
INSTRUMENT:            Sub Tek TX1/TX3 Send Command
INSTRUMENT:            Sub Tek TX1/TX3 Query Measurement
INSTRUMENT:            Sub Tek TX1/TX3 Error Message
INSTRUMENT:            Sub Tek TX1/TX3 AC Frequency Response ADJ
DATE:                  2011-06-24 10:55:56
AUTHOR:                Fluke Corporation
REVISION:              $Revision: 1.2 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       6
NUMBER OF LINES:       402
=============================================================================
#
#  Text Source:
#    $RCSfile: sub_tek_tx1_tx3_utils.txt,v $
#    $Date: 2007/04/11 18:47:24 $
#
# Compatibility:
#        MET/CAL or 5500/CAL, 7.01 SP2 and later
#
# Required Files:
#        metfir.exe
#
# These subprocedure(s) are generic and can be used for either the Tektronix
#    TX1 or TX3.
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON
  1.001  JMPL         QUERY_IDENTIFICATION         PSUBI("Identification")
  1.002  JMPL         SEND_COMMAND                 PSUBI("Send Command")
  1.003  JMPL         QUERY_MEASUREMENT            PSUBI("Query Measurement")
  1.004  JMPL         ERROR_MESSAGE                PSUBI("Error Message")
  1.005  JMPL         AC_FREQ_RESPONSE             PSUBI("Frequency")
  1.006  DISP         Error Tek TX1/TX3 Utilities:  Subprocedure not found!
  1.007  END

  1.008  EVAL   dummy

# ====== Sub Tek TX1/TX3 Query Identification =============================

# This subprocedure queries the Tek TX1/TX3 for its configuration info.

# STRING VARIABLE USAGE
#
#        S[1]  - Manufacturer's name (hard-coded)
#        S[2]  - Model number (derived from ID response)
#        S[3]  - Firmware version (parsed from ID response)
#        S[9]  - UUT model (from calling procedure)
#        S[11] - Serial port used (from calling procedure)
#        S[32] - Used to facilitate loading of data into 'variable.dat'.

  2.001  LABEL        QUERY_IDENTIFICATION
# Backup MEM and MEM1.
  2.002  MATH         L[1] = MEM; L[2] = MEM1
  2.003  MATH         S[1] = "!V?"
  2.004  CALL         Sub Tek TX1/TX3 Send Command
  2.005  JMPL         END_QUERY_IDENTIFICATION     GET("Error")

# Extracts Mfr. name and store in S[1].
  2.006  MATH         S[1] = "TEKTRONIX"
# Extracts model number and store in S[2].
  2.007  MATH         S[2] = FLD(MEM2, 2, ",") ; S[2] = SUB(S[2], 7, 3)

  2.008  IF           ZCMP(S[2], S[9]) == 0
  2.009  DISP         A Tektronix [SREG2], not a [SREG9] was found
  2.009  DISP         on [SREG11]!
  2.009  DISP
  2.009  DISP         Select "Terminate" to abort the procedure, choose
  2.009  DISP         the correct model, then restart the procedure.
  2.010  END
  2.011  ENDIF

# Extracts firmware version and store in S[3].
  2.012  MATH         S[3] = FLD(FLD(MEM2, 2, ";"), 1, ",")
# Format firmware revision number.
  2.013  MATH         S[3] = FMT(S[3], "%4.2f")
# Store extracted UUT information in variable .dat.
  2.014  MATH         S[32] = PUTV("Manufacturer", S[1])
  2.015  MATH         S[32] = PUTV("Model_Num", S[2])
  2.016  MATH         S[32] = PUTV("Firmware_Rev", S[3])

  2.017  MATH         MEM2 = "Firmware Version: " & S[3]
  2.018  RSLT         =
  2.019  HEAD         {INSTALLED INSTRUMENT FIRMWARE}
  2.020  RSLT         =
  2.021  RSLT         = [MEM2]

  2.022  DISP         Manufacturer  : [S1]
  2.022  DISP         Model         : [S2]
  2.022  DISP         Firmware Rev. : [S3]

  2.023  LABEL        END_QUERY_IDENTIFICATION
# Restore MEM and MEM1.
  2.024  MATH         MEM = L[1]; MEM1 = L[2]
  2.025  END

  2.026  EVAL   dummy

# ====== Sub Tek TX1/TX3 Send Command =====================================

# This subprocedure sends the command (in S[1]) to the Tek TX1/TX3 then
# checks its acknowledge response (0 = OK), (>0 = Error).

  3.001  LABEL        SEND_COMMAND
# Backup MEM and MEM1.
  3.002  MATH         L[1] = MEM; L[2] = MEM1
  3.003  MATH         S[32] = PUT("Error", "0"); S[32] = PUT("ErrMsg", "")
  3.004  PORT         [SREG1][13][I$]
  3.005  MATH         MEM = SUB(MEM2, 2, 1)
  3.006  JMPL         END_SEND_COMMAND             MEM == 0
  3.007  CALL         Sub Tek TX1/TX3 Error Message
  3.008  MATH         S[32] = GET("ErrMsg")
  3.009  OPBR         [S32]
  3.009  OPBR
  3.009  OPBR         Do you wish to RESEND the command?
  3.010  JMPL         SEND_COMMAND                 MEM1 > 0

  3.011  LABEL        END_SEND_COMMAND
# Restore MEM and MEM1.
  3.012  MATH         MEM = L[1]; MEM1 = L[2]
  3.013  END

  3.014  EVAL   dummy

# ====== Sub Tek TX1/TX3 Query Measurement ================================

# These subprocedures check the queried measurement value of Input A (B)
# for invalid (9.91e37) or overload (9.9e37 or -9.9e37).  If 5x invalid or
# overload then result is fail.
#
# S[1] must contain the Query Measurement command (e.g., "!M?") when
# this subprocedure is called.
#
# M[60] = number of seconds to delay before taking measurement

  4.001  LABEL        QUERY_MEASUREMENT
# Backup MEM1.
  4.002  MATH         L[2] = MEM1
  4.003  MATH         S[32] = PUT("Error", "0"); S[32] = PUT("ErrMsg", "")
# Set invalid/overload measurement counter.
  4.004  MATH         L[5] = 5

  4.005  DO

  4.006  IF           M[60] > 1
  4.007  WAIT         -t [M60] System settling...
  4.008  ELSE
  4.009  WAIT         [D1000]
  4.010  ENDIF

  4.011  CALL         Sub Tek TX1/TX3 Send Command
  4.012  JMPL         END_QUERY_MEASUREMENT        GET("Error")
# Read measurement.
  4.013  MATH         MEM = FLD(MEM2, 2, ";")
  4.014  MATH         L[5] = L[5] - 1
# Repeat if invalid reading or overload condition.
  4.015  UNTIL        (L[5] <= 0) || (ABS(MEM) < 1E+10)

  4.016  LABEL        END_QUERY_MEASUREMENT
# Restore MEM1.
  4.017  MATH         MEM1 = L[2]
  4.018  END

  4.019  EVAL   dummy

# ====== Sub Tek TX1/TX3 Error Messsage ===================================

# Based on the acknowledge response sent by the TX1/TX3, this procedure
# identifies the error for presentation to the operator.

  5.001  LABEL        ERROR_MESSAGE

  5.002  IF           MEM == 1
  5.003  MATH         S[32] = PUT("ErrMsg", "Framing Error")
  5.004  ELSEIF       MEM == 2
  5.005  MATH         S[32] = PUT("ErrMsg", "Parity Error")
  5.006  ELSEIF       MEM == 3
  5.007  MATH         S[32] = PUT("ErrMsg", "Overrun Error")
  5.008  ELSEIF       MEM == 4
  5.009  MATH         S[32] = PUT("ErrMsg", "Time out Error")
  5.010  ELSEIF       MEM == 5
  5.011  MATH         S[32] = PUT("ErrMsg", "Parameter Out of Range")
  5.012  ELSEIF       MEM == 6
  5.013  MATH         S[32] = PUT("ErrMsg", "Unknown Command")
  5.014  ELSEIF       MEM == 7
  5.015  MATH         S[32] = PUT("ErrMsg", "Input Buffer Overflow")
  5.016  ELSEIF       MEM == 8
  5.017  MATH         S[32] = PUT("ErrMsg", "Command Locked Out")
  5.018  ELSEIF       MEM == 9
  5.019  MATH         S[32] = PUT("ErrMsg", "Command Format Error")
  5.020  ELSE
  5.021  MATH         MEM2 = "Unknown Error! Acknowledge Response is " & MEM
  5.022  MATH         S[32] = PUT("ErrMsg", MEM)
  5.023  ENDIF

  5.024  MATH         S[32] = PUT("Error", "1")
  5.025  END

  5.026  EVAL   dummy

# ====== Sub Tek TX1/TX3 AC Frequency Response ============================

#  Variable Use:
#        M[1]  = Default Gain constant value sent to initialize UUT.
#        M[3]  = Default Gain constant value sent to initialize UUT.
#        M[5]  = Default Gain constant value sent to initialize UUT.
#        M[7]  = Default Gain constant value sent to initialize UUT.
#        M[9]  = Default Gain constant value sent to initialize UUT.
#        M[11] = Default Gain constant value sent to initialize UUT.
#        M[13] = Default Gain constant value sent to initialize UUT.
#        M[15] = Default Gain constant value sent to initialize UUT.
#        M[17] = Gain constant value sent to the UUT.
#        M[18] = Gain constant value sent to the UUT.
#        M[19] = Gain constant value sent to the UUT.
#        M[20] = Gain constant value sent to the UUT.
#        M[21] = Gain constant value sent to the UUT.
#        M[22] = Gain constant value sent to the UUT.
#        M[23] = Gain constant value sent to the UUT.
#        M[24] = Gain constant value sent to the UUT.
#        M[25] = Gain constant value sent to the UUT.
#        M[26] = DAC constant value sent to the UUT.
#        M[27] = Gain constant value sent to the UUT.
#        M[28] = Gain constant value sent to the UUT.
#
#        M[29] - M[39] = Default values sent to the UUT.
#        M[40] = UUT 2.5 MHz Clock value.
#        M[41] = UUT Decimation value.
#        M[42] = UUT Range number (from calling procedure)
#
#        S[5]   = Metcal.ini path information used for executable
#

  6.001  LABEL        AC_FREQ_RESPONSE
# Preload MATH register values for use by "metfir.exe" executable.
  6.002  MATH         M[1]=40; M[3]=100; M[5]=1000; M[7]=4000; M[9]=7000
  6.003  MATH         M[11]=10000; M[13]=15000; M[15]=20000
  6.004  MATH         M[17]=-9; M[18]=93; M[19]=-208; M[20]=-38; M[21]=822
  6.005  MATH         M[22]=-1003; M[23]=-1022; M[24]=3738; M[25]=-1592
  6.006  MATH         M[26]=-7946; M[27]=13221; M[28]=32767; M[29]=0
  6.007  MATH         M[30]=0; M[31]=0; M[32]=0; M[33]=0; M[34]=0; M[35]=0
  6.008  MATH         M[36]=0; M[37]=0; M[38]=0; M[39]=0

# Read 2.5 MHz Clock value.
  6.009  MATH         S[1] = "!n?"
  6.010  CALL         Sub Tek TX1/TX3 Send Command
  6.011  MATH         M[40] = FLD(MEM2, 2, ";")

# Decimation Value
  6.012  MATH         M[41] = 25
# Load path information from 'metcal.ini' into S[5].
  6.013  MATH         S[5] = IFILE()
# Call to 'metfir.exe' custom executable.
  6.014  DOS          -n -x metfir.exe [S5] 8 1

  6.015  LABEL        !A00_constant
# Compute new gain setting for UUT.
  6.016  MATH         M[17] = M[17] / 10E+9
# Pad M[17] with leading zeros.
  6.017  MATH         S[17] = FLD(FMT(M[17], "%12.10f"), 2, ".")

  6.018  IF           SGN(M[17]) == 1
  6.019  MATH         S[1] = "!A00+" & S[17]
  6.020  ELSE
  6.021  MATH         S[1] = "!A00-" & S[17]
  6.022  ENDIF

  6.023  CALL         Sub Tek TX1/TX3 Send Command

  6.024  LABEL        !A01_constant
  6.025  MATH         M[18] = M[18] / 10E+9
  6.026  MATH         S[18] = FLD(FMT(M[18], "%12.10f"), 2, ".")

  6.027  IF           SGN(M[18]) == 1
  6.028  MATH         S[1] = "!A01+" & S[18]
  6.029  ELSE
  6.030  MATH         S[1] = "!A01-" & S[18]
  6.031  ENDIF

  6.032  CALL         Sub Tek TX1/TX3 Send Command

  6.033  LABEL        !A02_constant
  6.034  MATH         M[19] = M[19] / 10E+9
  6.035  MATH         S[19] = FLD(FMT(M[19], "%12.10f"), 2, ".")

  6.036  IF           SGN(M[19]) == 1
  6.037  MATH         S[1] = "!A02+" & S[19]
  6.038  ELSE
  6.039  MATH         S[1] = "!A02-" & S[19]
  6.040  ENDIF

  6.041  CALL         Sub Tek TX1/TX3 Send Command

  6.042  LABEL        !A03_constant
  6.043  MATH         M[20] = M[20] / 10E+9
  6.044  MATH         S[20] = FLD(FMT(M[20], "%12.10f"), 2, ".")

  6.045  IF           SGN(M[20]) == 1
  6.046  MATH         S[1] = "!A03+" & S[20]
  6.047  ELSE
  6.048  MATH         S[1] = "!A03-" & S[20]
  6.049  ENDIF

  6.050  CALL         Sub Tek TX1/TX3 Send Command

  6.051  LABEL        !A04_constant
  6.052  MATH         M[21] = M[21] / 10E+9
  6.053  MATH         S[21] = FLD(FMT(M[21], "%12.10f"), 2, ".")

  6.054  IF           SGN(M[21]) == 1
  6.055  MATH         S[1] = "!A04+" & S[21]
  6.056  ELSE
  6.057  MATH         S[1] = "!A04-" & S[21]
  6.058  ENDIF

  6.059  CALL         Sub Tek TX1/TX3 Send Command

  6.060  LABEL        !A05_constant
  6.061  MATH         M[22] = M[22] / 10E+9
  6.062  MATH         S[22] = FLD(FMT(M[22], "%12.10f"), 2, ".")

  6.063  IF           SGN(M[22]) == 1
  6.064  MATH         S[1] = "!A05+" & S[22]
  6.065  ELSE
  6.066  MATH         S[1] = "!A05-" & S[22]
  6.067  ENDIF

  6.068  CALL         Sub Tek TX1/TX3 Send Command

  6.069  LABEL        !A06_constant
  6.070  MATH         M[23] = M[23] / 10E+9
  6.071  MATH         S[23] = FLD(FMT(M[23], "%12.10f"), 2, ".")

  6.072  IF           SGN(M[23]) == 1
  6.073  MATH         S[1] = "!A06+" & S[23]
  6.074  ELSE
  6.075  MATH         S[1] = "!A06-" & S[23]
  6.076  ENDIF

  6.077  CALL         Sub Tek TX1/TX3 Send Command

  6.078  LABEL        !A07_constant
  6.079  MATH         M[24] = M[24] / 10E+9
  6.080  MATH         S[24] = FLD(FMT(M[24], "%12.10f"), 2, ".")

  6.081  IF           SGN(M[24]) == 1
  6.082  MATH         S[1] = "!A07+" & S[24]
  6.083  ELSE
  6.084  MATH         S[1] = "!A07-" & S[24]
  6.085  ENDIF

  6.086  CALL         Sub Tek TX1/TX3 Send Command

  6.087  LABEL        !A08_constant
  6.088  MATH         M[25] = M[25] / 10E+9
  6.089  MATH         S[25] = FLD(FMT(M[25], "%12.10f"), 2, ".")

  6.090  IF           SGN(M[25]) == 1
  6.091  MATH         S[1] = "!A08+" & S[25]
  6.092  ELSE
  6.093  MATH         S[1] = "!A08-" & S[25]
  6.094  ENDIF

  6.095  CALL         Sub Tek TX1/TX3 Send Command

  6.096  LABEL        !A09_constant
  6.097  MATH         M[26] = M[26] / 10E+9
  6.098  MATH         S[26] = FLD(FMT(M[26], "%12.10f"), 2, ".")

  6.099  IF           SGN(M[26]) == 1
  6.100  MATH         S[1] = "!A09+" & S[26]
  6.101  ELSE
  6.102  MATH         S[1] = "!A09-" & S[26]
  6.103  ENDIF

  6.104  CALL         Sub Tek TX1/TX3 Send Command

  6.105  LABEL        !A10_constant
  6.106  MATH         M[27] = M[27] / 10E+9
  6.107  MATH         S[27] = FLD(FMT(M[27], "%12.10f"), 2, ".")

  6.108  IF           SGN(M[27]) == 1
  6.109  MATH         S[1] = "!A10+" & S[27]
  6.110  ELSE
  6.111  MATH         S[1] = "!A10-" & S[27]
  6.112  ENDIF

  6.113  CALL         Sub Tek TX1/TX3 Send Command

  6.114  LABEL        !A11_constant
  6.115  MATH         M[28] = M[28] / 10E+9
  6.116  MATH         S[28] = FLD(FMT(M[28], "%12.10f"), 2, ".")

  6.117  IF           SGN(M[28]) == 1
  6.118  MATH         S[1] = "!A11+" & S[28]
  6.119  ELSE
  6.120  MATH         S[1] = "!A11-" & S[28]
  6.121  ENDIF

  6.122  CALL         Sub Tek TX1/TX3 Send Command

  6.123  END
